package cn.com.qmth.importpaper;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import cn.com.qmth.multithread.Producer;


public class MyProducer extends Producer {
	private static Logger logger = LogManager.getLogger(MyProducer.class);
	private static String sourceDir = "d:/yunkai/";

	@Override
	protected void produce(Map<String, Object> param) throws Exception {
		logger.info("***************************任务生产开始");
		String sourceDir=param.get("sourceDir").toString();
		String host=param.get("host").toString();
		String rootOrgId=param.get("rootOrgId").toString();
		String key=param.get("key").toString();
		String token=param.get("token").toString();
//		List<Course> cs = readSubject();
		Map<String,ImportCourse> ics=readSubjectCodes();
		if (ics.size()==0) {
			logger.debug("无数据导入");
			return;
		} else {
			logger.debug(ics.size() + "个课程");
		}
		for (ImportCourse ic : ics.values()) {
			offer(new ConsumerDto(ic, sourceDir, host, rootOrgId, key, token));
		}
		logger.info("***************************任务生产结束");
	}
	
	private static Map<String,ImportCourse> readSubjectCodes() {
		Map<String,ImportCourse> map=new HashMap<>();
		XSSFWorkbook wb = null;
		try {
			wb = new XSSFWorkbook(sourceDir + "subject_info.xlsx");
			XSSFSheet sheet = wb.getSheetAt(0);
			int rows = sheet.getLastRowNum();
			for (int i = 1; i <= rows; i++) {
				Course c = new Course();
				XSSFRow row = sheet.getRow(i);
				String ecCode = row.getCell(0).getStringCellValue().trim();
				String yunCode = row.getCell(1).getStringCellValue().trim();
				String name = row.getCell(2).getStringCellValue().trim();
				c.setCode(ecCode);
				c.setName(name);
				ImportCourse ic=map.get(yunCode);
				if(ic==null) {
					ic=new ImportCourse();
					ic.setSubjectCode(yunCode);
					map.put(yunCode,ic);
				}
				ic.addCourse(c);
				
			}
		} catch (IOException e) {
			throw new RuntimeException(e);
		} finally {
			if (wb != null) {
				try {
					wb.close();
				} catch (IOException e) {
				}
			}
		}
		return map;
	}
	
//	private  List<Course> readSubject() {
//		List<Course> list = new ArrayList<>();
//		XSSFWorkbook wb = null;
//		try {
//			wb = new XSSFWorkbook(sourceDir + "subject.xlsx");
//			XSSFSheet sheet = wb.getSheetAt(0);
//			int rows = sheet.getLastRowNum();
//			for (int i = 1; i <= rows; i++) {
//				Course c = new Course();
//				XSSFRow row = sheet.getRow(i);
//				String id = row.getCell(0).getStringCellValue().trim();
//				String name = row.getCell(1).getStringCellValue().trim();
//				String code = row.getCell(2).getStringCellValue().trim();
//				c.setId(Long.valueOf(id));
//				c.setCode(code);
//				c.setName(name);
//				list.add(c);
//			}
//		} catch (IOException e) {
//			throw new RuntimeException(e);
//		} finally {
//			if (wb != null) {
//				try {
//					wb.close();
//				} catch (IOException e) {
//				}
//			}
//		}
//		return list;
//	}
}
